Subject: bug#50696: [core-updates-frozen] Wrong output hashes computed since cb06f7c61e4b839

From: Ludovic Courtès <[email-masked]>
Date: Mon, 20 Sep 2021 23:38:14 +0200

Hi Marius,

Marius Bakke <[email-masked]> skribis:

> On the 'core-updates-frozen' branch, attempting to pull 'master' gives a
> backtrace along the lines of ...
>
> Computing Guix derivation for 'x86_64-linux'... |Backtrace:

[...]

>   1. &store-protocol-error:
>       message: "derivation `/gnu/store/szv5fh043rrqq01xpycp7xci4y7myqfk-guile-3.0.7.tar.xz.drv' has incorrect output `/gnu/store/qwjhql8lqw40fqhaqw40jwqs0hc0248w-guile-3.0.7.tar.xz', should be `/gnu/store/0zliqv8lcw13f9iasy14kmwsqj3d309w-guile-3.0.7.tar.xz'"
>       status: 1
>
> I bisected it down to cb06f7c61e4b:
>
> commit cb06f7c61e4b8393abf38f1f5891e03c33d53b9b
> Author: Ludovic Courtès <[email-masked]>
> Date:   Thu Sep 9 23:22:10 2021 +0200
>
>     base32: Provide an open-coded 'bit-field'.
>
>     This improves the throughput of 'bytevector->base32-string' a bit.
>
>     * guix/base32.scm (bit-field): New macro.

The problem is that at -O1 with Guile 3.0.7 (which is the default for
imported modules on ‘core-updates-frozen’ since
331a09654eb7e9f6212b7e8469077fa7393e8b11), that code gets miscompiled:

--8<---------------cut here---------------start------------->8---
$ rm guix/base32.go
$ guild compile -O1 guix/base32.scm -o guix/base32.go
wrote `guix/base32.go'
$ ./pre-inst-env guile
GNU Guile 3.0.7
Copyright (C) 1995-2021 Free Software Foundation, Inc.

Guile comes with ABSOLUTELY NO WARRANTY; for details type `,show w'.
This program is free software, and you are welcome to redistribute it
under certain conditions; type `,show c' for details.

Enter `,help' for help.
scheme@(guile-user)> ,use(guix base32)
scheme@(guile-user)> (nix-base32-string->bytevector "0wqd8sjmxfskrflaxywc7gqw7sfawrfvdxd9skxawzfgyy0pzdz6")
$1 = #vu8(230 180 126 128 240 207 124 168 250 212 169 244 186 92 228 202 232 206 240 60 140 248 170 168 200 83 184 90 164 64 13 112)
scheme@(guile-user)> (bytevector->nix-base32-string $1)
$2 = "000d0080l00k00h0l00c0h00w00a0hq0lh090hl0hh0g0000wh06"
--8<---------------cut here---------------end--------------->8---

Long story short: the “baseline compiler” (-O0 and -O1) would
erroneously translate (ash x N) to (ash x (- N)) when N is a literal:

--8<---------------cut here---------------start------------->8---
scheme@(guix base32)> (compile '(lambda (x) (ash x -2)) #:to 'value #:env (current-module) #:optimization-level 1)
$46 = #<procedure 36aeed8 (x)>
scheme@(guix base32)> (compile '(lambda (x) (ash x -2)) #:to 'value #:env (current-module) #:optimization-level 2)
$47 = #<procedure 2e4d7a8 (x)>
scheme@(guix base32)> ($47 4)
$48 = 1
scheme@(guix base32)> ($46 4)
$49 = 16
--8<---------------cut here---------------end--------------->8---

Fixed upstream:

  https://git.savannah.gnu.org/cgit/guile.git/commit/?id=74abae04aa68dc18676bd84c4a73324b0613475d

However I’m not sure how to work around the bug, other than by reverting
the change.  I’ll think a bit more about it.

Thanks,
Ludo’.